# Intro to Genoa Banner Creator

This is yet another experimental tool for procedural art. Use simple scripts to describe graphical banners and posters with many repetitive elements, then export them as SVG for further use. Scripts can be edited and previewed in place for rapid turnaround.

Rationale: I make vector art by hand (see the Pocket Guide to Writing SVG, by Joni Trythall). It's a wonderful artistic medium, but turnaround can be slow between my text editor and image viewer. Also, that way it's hard to add repetitive elements. Genoa is meant to help with that as a first step, and for quick iteration of ideas.

## Availability

As of September 2023, Genoa is at a very early alpha stage: incomplete, undocumented and probably buggy. Use at your own risk. System requirements:

- to run from source, Tcl/Tk 8.6 with tklib
- screen resolution:
  - minimum 800x600
  - recommended 1280x800

## Usage

Genoa is powered by a little language based on Tcl. Right now it can generate its own promotional banner, like this:

```tcl
# The viewport declaration can be anywhere.
viewport 75 50 630 500

width 0
fill darkslategray
box 75 50 630 500
width 10
fill ""

proc circles {cx cy} {
	repeat 10 {
		incr i 30
		circle $cx $cy $i
	}
}
color darkred; circles 200 200
color green; circles 500 100
color darkblue; circles 400 400

font "Noto Sans"; size 48
color white; set j 0
foreach i {GENERATE ORIGINAL ART} {
	incr j 64
	text 225 [+ 225 $j] $i
}
```

Simply paste it in then hit Preview and/or Export. No need to save first.

## License and contact

Genoa is open source under the MIT License. Binary versions made with FreeWrap.

Feedback is welcome. I can be found most readily as @notimetoplay@elekk.xyz on Mastodon, or else in the #ctrl-c channel of tilde.chat (on IRC).
